#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "aube.h"

struct xm_sample *load_raw(char *filename)
{
   FILE *f;
   struct xm_sample *s;
   struct stat st;
   long len;
   
   f = fopen(filename, "r");
   
   s = (struct xm_sample *)malloc(sizeof(struct xm_sample));
   
   
   if(stat(filename, &st)<0) {
      perror(filename);
      return(0);
   }
   
   len = (long)st.st_size;
   
   s->data = (unsigned short *)malloc((size_t)len);
   
   s->sample_length = len/2;
   s->sample_loop_start = 0;
   s->sample_loop_length = 0;
   s->volume = 0xff;
   s->finetune = 0x0;
   s->type = 0x0;
   s->panning = 128;
   s->rel_note_number = 0;
   s->reserved = 0;
   strncpy(s->sample_name, filename, 23);
   
   fread(s->data, (size_t)len, (size_t)1, f);
   
   return s;
}
