#include <stdio.h>

#include "aube.h"
#include "aube_internal.h"

void preextend(struct xm_sample *sample)
{
   int i;
   unsigned short p;
   unsigned char d;
   bit16 ds;
   bit16 *s, *os, *ls, *le;
   bit16 *old_data;
   
   old_data = sample->data;

   if(sample->sample_loop_length > 0 &&   
      (sample->sample_loop_start + sample->sample_loop_length <=
       sample->sample_length)) {
/*         
      fprintf(stderr, "considering looping ...\n");
      fprintf(stderr, "sample length: %d\n", sample->sample_length);
      fprintf(stderr, "loop start: %d\n", sample->sample_loop_start);
      fprintf(stderr, "loop length: %d\n", sample->sample_loop_length);
      fprintf(stderr, "loop end: %d\n\n", sample->sample_loop_start + sample->
	      sample_loop_length);   
*/         
      sample->data = (bit16 *)malloc((size_t)sample->sample_length + SAMPLE_EXTEND);
      sample->postloop = (bit16 *)malloc((size_t)(sample->sample_length -
						  (sample->sample_loop_start + sample->sample_loop_length)));
      
      os = old_data;
      s = sample->data;
      
      p = 0x00;
      
      for(i=0; i<(sample->sample_loop_start>>1); i++) {
	 *(s++) = *(os++);
      }
      ls=s;
      for(;i<((sample->sample_loop_start + sample->sample_loop_length)>>1);i++) {
	 *(s++) = *(os++);
      }
      le=s;
      os=ls;
      for(;i<((sample->sample_length + SAMPLE_EXTEND)>>1); i++) {
	 *(s++) = *(os++);
	 if(os>=le) os=ls;
      }
      
      /* fill postloop */
      s = sample->postloop;
      os = old_data + (sample->sample_loop_start + sample->sample_loop_length);
      for(i=0;
	  i<((sample->sample_length -
	      (sample->sample_loop_start + sample->sample_loop_length))>>1);
	  i++) {
	 *(s++) = *(os++);
      }
      
      free(old_data);
      
   }
   else {
      sample->postloop = NULL;
      
      s = sample->data + (sample->sample_length>>1);
      
      sample->sample_loop_start = 0;
      sample->sample_loop_length = 0;
      
      for(i=0; i<SAMPLE_EXTEND>>1; i++) {
	 *(s++) = 0x0;
      }
   }  
}
