/*
 * sync.c
 * 
 * display synchronisation
 */

#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/time.h>

#include <aube.h>

extern struct xm *mod;
extern struct xm_pattern *current_pattern;
extern int current_instrument_number;
extern int current_row;
extern int current_track;
extern int current_pos;

extern int song_pos;

extern int playing;

/*********** ALARM SIG HANDLER *******************/
void handler_alarm(int sig)
{
   struct itimerval itv;
   
   if(playing) {
      signal(sig, handler_alarm);
      if(current_row >= (current_pattern->num_rows-1)) {
	 current_row=0;
	 song_fwd_button_pressed();
	 change_current_pattern_number(mod->pattern_order_table[song_pos]);
      }
      else {
	 scroll_by(2);
      }
   }
}

void start_sync(void)
{
   struct itimerval itv;
   int row_rt;

   row_rt = 2 * mod->tempo * 14500000 / (mod->bpm * 6);
   
   signal(SIGALRM, handler_alarm);
   itv.it_interval.tv_usec = row_rt;
   itv.it_interval.tv_sec = 0;
   itv.it_value.tv_usec = row_rt;
   itv.it_value.tv_sec = 0;
   
   setitimer(ITIMER_REAL, &itv, (struct itimerval *)0);
}

void stop_sync(void)
{
   signal(SIGALRM, SIG_IGN);
}

