#include <stdio.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

#include <aube.h>

#include "zap_requester.h"
#include "button.h"

extern char *progname;

extern Display *display;
extern unsigned int display_depth;
extern int screen_num;

extern struct xm *mod;


Window zap_top;

struct button_data *zap_all_button;
struct button_data *zap_patterns_button;
struct button_data *zap_instruments_button;
struct button_data *zap_cancel_button;

static int pos_x = 0, pos_y = 0;

static Pixmap pixmap;

static int width, height;
static int button_width, button_height;

static int max_height;
static int eof = 0;

void zap_all_button_pressed(void)
{
   close_zap_window();
   clear_xm(mod);
}

void zap_patterns_button_pressed(void)
{
   close_zap_window();
   free_xm_patterns_all(mod);
}

void zap_instruments_button_pressed(void)
{
   close_zap_window();
   free_xm_instruments_all(mod);
}

void zap_cancel_button_pressed(void)
{
   close_zap_window();
}


void create_zap_window(void)
{
   char *window_name = "maube zapper";
   char *icon_name = "maube zapper";

   width = 310;
   height = 100;
   
   button_width = 60;
   button_height = 20;
   
   zap_top = create_toplevel_window(window_name, icon_name,
					0, 0, width, height, 200, 100);

   zap_all_button =
     create_text_button(zap_top, 20, height - 30,
			button_width, button_height,
			(void *)zap_all_button_pressed,
			(char *)"zap all",
			(char *)"complete carnage maaaaate!");

   zap_patterns_button =
     create_text_button(zap_top,
			90, height - 30,
			button_width, button_height,
			(void *)zap_patterns_button_pressed,
			(char *)"zap patt",
			(char *)"patterns of death.");
   
   zap_instruments_button =
     create_text_button(zap_top,
			160, height - 30,
			button_width, button_height,
			(void *)zap_instruments_button_pressed,
			(char *)"zap instr",
			(char *)"instrumental mutilation");

   zap_cancel_button =
     create_text_button(zap_top,
			230, height - 30,
			button_width, button_height,
			(void *)zap_cancel_button_pressed,
			(char *)"cancel",
			(char *)"eradicate all traces of your feeeble existence.");
   
   XMapWindow(display, zap_top);
}

void close_zap_window(void)
{
   if(zap_top != 0L) {
      XDestroyWindow(display, zap_top);
   }
   XFlush(display);
}

