#ifndef __FILEREQUEST_H__
#define __FILEREQUEST_H__

#include "panel.h"
#include "button.h"
#include "textfield.h"
#include "textlist.h"

struct string_entry {
   char string[256];
};

struct string_list {
   struct string_entry *e;
   struct string_list *next;
};

struct filerequest {
   Window window;
   int width, height;
   char *selected_filename;
   void (*selected)(char *filename);
   struct panel *choice_panel;
   struct button_data *file_ok_button;
   struct button_data *file_cancel_button;
   struct textfield *file_cwd;
   struct textfield *file_fname;
   struct textlist *file_list;
   char dirname[256];
   int dirname_size;
   char ***filenames;
   int num_files;
};

struct filerequest_list {
   struct filerequest *data;
   struct filerequest_list *next;
};


int check_filerequests_destroyed(XEvent report);
void add_filerequest(struct filerequest *f);
void file_ok_button_pressed(void);
void file_cancel_button_pressed(void);
void file_cwd_changed(char *s);
void file_fname_changed(char *s);
void file_selected(int list_index);
void change_directory(struct filerequest *f, char *s);
void create_filerequest(void *selected_func());
char ***get_file_names(void);
struct string_list *get_file_string_list(void);
struct string_list *sort_file_string_list(struct string_list *sl);
struct string_list *insert_fslist(struct string_list *sl, struct string_list *isl);
void free_string_list(struct string_list *sl);
void clear_filerequest_window(struct filerequest *f);
void close_filerequest_window(struct filerequest *f);


#endif  /*  __FILEREQUEST_H__ */
