#ifndef __NUMRANGE_H__
#define __NUMRANGE_H__

#include "button.h"
#include "label.h"
#include "numrange_handle.h"

struct numrange {
   int width, height;

   int val, min, max;
   
   struct label *numdisplay;
   struct numrange_handle *handle;
   struct button_data *downbutton;
   struct button_data *upbutton;
   
   void (*changed)(int new_val);
};

struct numrange *create_numrange(Window parent, int x, int y,
				 int width, int height,
				 int init_val, int min, int max,
				 void *changed());

void numrange_bounds(struct numrange *n);
void refresh_numrange(struct numrange *n);

#endif /*  __NUMRANGE_H__  */
