#ifndef __NUMRANGE_HANDLE_H__
#define __NUMRANGE_HANDLE_H__

struct numrange_handle {
   Window window;
   int x, y, width, height;
   int mx, my;
   void (*moved)(void *a, int y);
   void *arg;
   Pixmap unset_pixmap;
   Pixmap set_pixmap;
   Pixmap hl_pixmap;
   Pixmap current_pixmap;
};

struct numrange_handle_list {
   struct numrange_handle *data;
   struct numrange_handle_list *next;
};

struct numrange_handle *create_numrange_handle(Window parent, int x, int y,
					   int width, int height,
					   void *moved_func(), void *arg);
void refresh_numrange_handle(struct numrange_handle *numrange_handle);

#endif /*  __NUMRANGE_HANDLE_H__  */
