#ifndef __SCROLL_HANDLE_H__
#define __SCROLL_HANDLE_H__

struct scroll_handle {
   Window window;
   int x, y, width, height;
   int mx, my;
   int min_y, max_y;
   void (*moved)(void *a, int y);
   void *arg;
   Pixmap unset_pixmap;
   Pixmap set_pixmap;
   Pixmap hl_pixmap;
   Pixmap current_pixmap;
};

struct scroll_handle_list {
   struct scroll_handle *data;
   struct scroll_handle_list *next;
};

void refresh_scroll_handle(struct scroll_handle *scroll_handle);
struct scroll_handle *create_scroll_handle(Window parent, int x, int y,
					   int width, int height,
					   int min_y, int max_y,
					   void *moved_func(), void *arg);

#endif /*  __SCROLL_HANDLE_H__  */
