#ifndef __SCROLLBAR_H__
#define __SCROLLBAR_H__

#include "button.h"
#include "scroll_handle.h"

struct button_arg {
   struct scrollbar *s;
   void *a;
};

struct scrollbar {
   int width, height;

   int val, min, max, view;
   
   Window container;
   
   struct button_data *downbutton;
   struct button_data *upbutton;
   
   struct scroll_handle *handle;
   
   void (*changed)(void *owner, int new_val);
   
   Pixmap pixmap;
};

struct scrollbar_list {
   struct scrollbar *data;
   struct scrollbar_list *next;
};

struct scrollbar *create_scrollbar(Window parent, int x, int y,
				 int width, int height,
				 int init_val, int min, int max, int view,
				 void *changed(), void *arg);
void scrollbar_bounds(struct scrollbar *s);
void refresh_scrollbar(struct scrollbar *s);
void refresh_scrollbar_resize(struct scrollbar *s);
Pixmap create_scrollbar_pixmap(Window window,
			       unsigned int width, unsigned int height);


#endif /*  __SCROLLBAR_H__  */
