#ifndef __TEXTFIELD_H__
#define __TEXTFIELD_H__

#include <X11/Xlib.h>

#define LEFT_JUSTIFY 0
#define RIGHT_JUSTIFY 1
#define CENTRE_JUSTIFY 2
#define CENTER_JUSTIFY CENTRE_JUSTIFY

#define CURSOR_OFF -1

struct textfield {
   Window window;
   int width, height;
   void (*changed)(char *s);
   char text[256];
   int justify;
   int cursor;
};

struct textfield_data_list {
   struct textfield *data;
   struct textfield_data_list *next;
};

int check_textfields_destroyed(XEvent report);
struct textfield *create_textfield(Window parent, int x, int y, int width, int height,
		   void *changed_func(), char *init_str, int justify);
int check_textfields_pressed(XEvent report);
int check_textfields_mouseover(XEvent report);
int check_textfields_mouseexit(XEvent report);
int check_textfields_expose(XEvent report);
int check_textfields_keypress(XEvent report);
void refresh_textfield(struct textfield *t);
void cursor_left(struct textfield *t);
void cursor_right(struct textfield *t);
void insert_char(struct textfield *t, char *c);
void delete_next_char(struct textfield *t);
void delete_prev_char(struct textfield *t);
void delete_char(struct textfield *t, int pos);
void change_textfield_text(struct textfield *t, char *new_text);

#endif /*  __TEXTFIELD_H__  */
