#ifndef __TEXTLIST_H__
#define __TEXTLIST_H__

#include "scrollbar.h"

#define DOUBLECLICK_TIME 500

struct textcolumn {
   Pixmap pixmap;
   
   int x;
   int width;
};

struct textlist {
   Window window;

   Window listwin;
   
   struct scrollbar *scrollbar;
   
   int x, y, width, height;

   void (*changed)(int val);
   void (*chosen)(int val);
   
   int rows, cols;
   int curr_row, top_row, rows_visible;

   Time time;
   
   char ***cells;
  
   struct textcolumn **columns;
   
   Pixmap back_pixmap;
};

struct textlist_list {
   struct textlist *data;
   struct textlist_list *next;
};

void scroll_textlist(struct textlist *t, int new_top_row);
int check_textlists_destroyed(XEvent report);

struct textlist *create_textlist(Window parent, int x, int y, int width, int height,
				 void *changed(), void *chosen(),
				 int rows, int cols, char ***cells);
void update_textlist(struct textlist *t, int rows, int cols, int curr_row, char ***cells);
void render_column_pixmaps(struct textlist *t);
Pixmap render_column_pixmap(struct textlist *t, int i);
void refresh_textlist(struct textlist *t);
void render_textlist_back_pixmap(struct textlist *t);
void render_textlist(struct textlist *t);
void select_item(struct textlist *t, int x, int y);
void change_selection(struct textlist *t, int sel);
int check_textlists_pressdown(XEvent report);
int check_textlists_pressed(XEvent report);
int check_textlists_motion(XEvent report);
int check_textlists_mouseover(XEvent report);
int check_textlists_mouseexit(XEvent report);
int check_textlists_expose(XEvent report);


#endif  /*  __TEXTLIST_H__  */
