#ifndef __TOGGLE_H__
#define __TOGGLE_H__

#include <X11/Xlib.h>

struct toggle_data {
   Window window;
   int width, height;
   void (*pressed)(void);
   void (*released)(void);
   int state; /* boolean */
   char *status_text;
   Pixmap unset_pixmap;
   Pixmap set_pixmap;
   Pixmap hl_pixmap;
   Pixmap current_pixmap;
};

struct toggle_data_list {
   struct toggle_data *data;
   struct toggle_data_list *next;
};

struct toggle_data *create_toggle(Window parent, int x, int y, int width, int height,
				  void *pressed_func(), void *released_func(),
				  char *st,
				  Pixmap unset_pixmap, Pixmap set_pixmap,
				  Pixmap hl_pixmap);
struct toggle_data *create_text_toggle(Window parent, int x, int y,
				       int width, int height,
				       void *pressed_func(),
				       void *released_func(),
				       char *text,
				       char *st);
struct toggle_data *create_play_toggle(Window parent, int x, int y,
				       int width, int height,
				       void *pressed_func(), 
				       void *released_func(), char *st);
int check_toggles_pressdown(XEvent report);
int check_toggles_pressed(XEvent report);
int check_toggles_mouseover(XEvent report);
int check_toggles_mouseexit(XEvent report);
int check_toggles_expose(XEvent report);
void toggle_toggle(struct toggle_data *toggle);
void set_toggle_state(struct toggle_data *toggle, int newstate);
void refresh_toggle_state(struct toggle_data *toggle);
void refresh_toggle(struct toggle_data *toggle);

#endif /*  __TOGGLE_H__  */
